# Le programme fonctionne principalement grace a des heuristiques

from api import *
from math import *

d1, d2 = 0, 0

#Donne l'echantillon le plus desavantageant a l'adversaire
def minEl():
	(a, b) = echantillon_tour()
	res, sco = 0, 99999
	for i in range(1, 6):
		if met2[i] != a:
			m = maxScoE((a, met2[i]))
			if m < sco:
				res, sco = (a, met2[i]), m
		if met2[i] != b:
			m = maxScoE((b, met2[i]))
			if m < sco:
				res, sco = (b, met2[i]), m
	donner_echantillon(res)
	return res

#Retourne le score maximale que peut faire l'adversaire avec l'echantillon ech
def maxScoE(ech):
	poss = placements_possible_echantillon(ech, lui)
	if len(poss) == 0:
		return 0
	maax = evalP(poss[0], ech, lui, False)
	for j in range(1, len(poss)):
		maax = max(maax, evalP(poss[j], ech, lui, False))
	return maax

#Cree une matrice de booleens False de taille 6*6
def createCheck():
	return [[False for i in range(6)] for j in range(6)]

#Renvoie True si il existe une case vide libre autour de la region de l'element en position x y
def libre(x, y, checked):
	M = type_case((x, y), moi)
	checked[x][y] = True
	if x > 0:
		N = type_case((x-1, y), moi)
		if N == met[0] or (N == M and not(checked[x-1][y]) and libre(x-1, y, checked)):
			return True
	if x < 5:
		N = type_case((x+1, y), moi)
		if N == met[0] or (N == M and not(checked[x+1][y]) and libre(x+1, y, checked)):
			return True
	if y > 0:
		N = type_case((x, y-1), moi)
		if N == met[0] or (N == M and not(checked[x][y-1]) and libre(x, y-1, checked)):
			return True
	if y < 5:
		N = type_case((x, y+1), moi)
		if N == met[0] or (N == M and not(checked[x][y+1]) and libre(x, y+1, checked)):
			return True

#Realise une transmutation si besoin sur les carres adjacents a la position a
def trans(a):
	x, y = a
	if x > 0 and taille_region((x-1, y), moi) >= 3 and not(libre(x-1, y, createCheck())):
		transPC((x-1, y))
	if x < 5 and taille_region((x+1, y), moi) >= 3 and not(libre(x+1, y, createCheck())):
		transPC((x+1, y))
	if y > 0 and taille_region((x, y-1), moi) >= 3 and not(libre(x, y-1, createCheck())):
		transPC((x, y-1))
	if y < 5 and taille_region((x, y+1), moi) >= 3 and not(libre(x, y+1, createCheck())):
		transPC((x, y+1))

#Realise les transmutation necessaires apres avoir place un echantillon a la position pos
def transP(pos):
	a, b = pos
	trans(a)
	trans(b)

#Realise toutes les transmutations possibles des regions de taille superieur a n
def supp(n):
	bo = False
	for x in range(6):
		for y in range(6):
			if taille_region((x, y), moi) >= n:
				transPC((x, y))
				bo = True
	if bo:
		supp(n)

#Evalue la valeur d'une position pos pour un element el pour le joueur joueur
def eva(pos, el, joueur):
	x, y = pos
	res = 0.0
	for i in range(6):
		for j in range(6):
			if i != x or j != y:
				c = type_case((i, j), joueur)
				if c == el:
					res += 1.0/(sqrt((x-i)**2 + (y-j)**2))
					if i == x or j == y:
						res += 0.54/sqrt((abs(x-i) + abs(y-j)))
				elif c == met2[0]:
					res += 0.185/(abs(x-i) + abs(y-j))
				else:
					res -= 0.205/(sqrt((x-i)**2 + (y-j)**2))
	return res

#Evalue la pose d'un echantillon ech en pos pour le joueur joueur. Si preCata vaut True, la catalyse est priviliegiee
def evalP(pos, ech, joueur, preCata):
	poss = []
	ajo = - valOr(pos[0], poss, joueur) - valOr(pos[1], poss, joueur)
	poss = []
	placer_echantillon(pos[0], pos[1])
	ajo += valOr(pos[0], poss, joueur) + valOr(pos[1], poss, joueur)
	annuler()
	if preCata:
		for x in range(6):
			for y in range(6):
				tc = type_case((x, y), lui)
				if tc == met2[3] or tc == met2[5] and taille_region((x, y), moi) >= 3:
					ajo += 0.6
	return eva(pos[0], ech[0], joueur) + eva(pos[1], ech[1], joueur) + ajo

#Realise la meilleur pose parmi les positions de poss pour l'ecantillon ech
def bestP(poss, ech):
	preCata = bestRE() > 7
	maax, i = evalP(poss[0], ech, moi, preCata), 0
	for j in range(1, len(poss)):
		nm = evalP(poss[j], ech, moi, preCata)
		if nm > maax:
			maax = nm
			i = j
	placer_echantillon(poss[i][0], poss[i][1])
	transP(poss[i])

#Realise la meilleur catalyse sur le joueur joueur. mul est positif si on veut maximiser l'or et negatif si on veut le diminuer
def bestC(joueur, mul):
	x0, y0, n, el = 0, 0, 0, 0
	for x in range(6):
		for y in range(6):
			if type_case((x, y), joueur) != met2[0]:
				anc = valOr((x, y), [], joueur)
				for i in range(1, 5):
					catalyser((x, y), joueur, met2[i])
					nn = mul * (valOr((x, y), [], joueur) - anc)
					if nn > n:
						x0, y0, n, el = x, y, nn, met2[i]
					annuler()
	if n > 0:
		catalyser((x0, y0), joueur, el)
	return n

#Realise le meilleur couple de catalyses sur le joueur joueur. mul est positif si on veut maximiser l'or et negatif si on veut le diminuer
def bestC2(joueur, mul):
	x0, y0, x1, y1, n, el = 0, 0, 0, 0, 0, 0
	for x in range(6):
		for y in range(6):
			if type_case((x, y), joueur) != met2[0]:
				if x < 5 and type_case((x+1, y), joueur) != met2[0]:
					poss = []
					anc = valOr((x, y), poss, joueur) + valOr((x+1, y), poss, joueur)
					for i in range(1, 5):
						if type_case((x, y), joueur) == met2[i] or type_case((x+1, y), joueur) == met2[i]:
							continue
						catalyser((x, y), joueur, met2[i])
						catalyser((x+1, y), joueur, met2[i])
						poss = []
						nn = mul * (valOr((x, y), poss, joueur) + valOr((x+1, y), poss, joueur) - anc)
						if nn > n:
							x0, y0, x1, y1, n, el = x, y, x+1, y, nn, met2[i]
						annuler()
						annuler()
				if y < 5 and type_case((x, y+1), joueur) != met2[0]:
					poss = []
					anc = valOr((x, y), poss, joueur) + valOr((x+1, y), poss, joueur)
					for i in range(1, 5):
						if type_case((x, y), joueur) == met2[i] or type_case((x, y+1), joueur) == met2[i]:
							continue
						catalyser((x, y), joueur, met2[i])
						catalyser((x, y+1), joueur, met2[i])
						poss = []
						nn = mul * (valOr((x, y), poss, joueur) + valOr((x, y+1), poss, joueur) - anc)
						if nn > n:
							x0, y0, x1, y1, n, el = x, y, x, y+1, nn, met2[i]
						annuler()
						annuler()
	n21, n22 = bestC(joueur, mul), bestC(joueur, mul)
	if n21+n22 > n:
		if n22 > 0:
			return (n21+n22, 2)
		else:
			return (n21, 1)
	else:
		if n21 > 0 :
			annuler()
		if n22 >0:
			annuler()
	if n > 0:
		catalyser((x0, y0), joueur, el)
		catalyser((x1, y1), joueur, el)
	return (n, 2)

#Realise toutes les meilleurs catalyses possibles
def playC():
	bo = True
	ca = nombre_catalyseurs()
	while bo and (ca > 0):
		if ca > 1:
			b1 = bestC2(lui, -1.0)
			if b1[0] > 0:
				for i in range(b1[1]):
					annuler()
			b2 = bestC2(moi, 1.0)
			if b2[0] >= b1[0] + 1.8 or b1[0] == 0:
				if b2[0] > 0:
					ca -= b2[1]
				else:
					bo = False
			else:
				for i in range(b2[1]):
					annuler()
				ca -= b2[1]
				bestC2(lui, -1.0)
		else:
			b1 = bestC(lui, -1.0)
			if b1 > 0:
				annuler()
			b2 = bestC(moi, 1.0)
			if b2 >= b1 + 1 or b1 == 0:
				if b2 > 0:
					ca -= 1
				else:
					bo = False
			else:
				if b2 > 0:
					annuler()
				bestC(lui, -1.0)
				ca -= 1

#Realise une transmutation et les catalyses qui vont derriere a la position pos
def transPC(pos):
	transmuter(pos)
	playC()
	suppCata()

#Retourne la valeur en or des regions du voisinage de pos pour le joueur joueur sans regarder les regions de poss
def valOr(pos, poss, joueur):
	x, y = pos
	res = 0
	if not(pos in poss):
		poss += positions_region(pos, joueur)
		res += valOrR(pos, joueur)
	if x > 0 and not((x-1, y) in poss):
		poss += positions_region((x-1, y), joueur)
		res += valOrR((x-1, y), joueur)
	if x < 5 and not((x+1, y) in poss):
		poss += positions_region((x+1, y), joueur)
		res += valOrR((x+1, y), joueur)
	if y > 0 and not((x, y-1) in poss):
		poss += positions_region((x, y-1), joueur)
		res += valOrR((x, y-1), joueur)
	if y < 5 and not((x, y+1) in poss):
		poss += positions_region((x, y+1), joueur)
		res += valOrR((x, y+1), joueur)
	return res

#Retourne la valeur en or d'une region du joueur joueur
def valOrR(pos, joueur):
	tc = type_case(pos, joueur)
	if tc == met2[0]:
		return -0.5
	elif tc == met2[3] or tc == met2[5]:
		return max(-0.8, quantite_transmutation_catalyseur_or(taille_region(pos, joueur)))
	else:
		return max(-0.8, quantite_transmutation_or(taille_region(pos, joueur)))

#Amenage le terrain en supprimant les regions de taille au moins n afin de povoir poser l'echantillon ech
def amenage(n, ech):
	poss = placements_possible_echantillon(ech, moi)
	boo = True
	while len(poss) == 0 and boo:
		x, y = 0, 1
		ma, x0, y0 = taille_region((0, 0), moi), 0, 0
		while x < 6:
			while y < 6:
				m = taille_region((x, y), moi)
				if m > ma:
					ma, x0, y0 = m, x, y
				y += 1
			y = 0
			x += 1
		if ma >= n:
			transPC((x0, y0))
			poss = placements_possible_echantillon(ech, moi)
			if len(poss) > 0:
				tot = 0
				for x in range(6):
					for y in range(6):
						if type_case((x, y), moi) != met2[0] and taille_region((x, y), moi) < 3:
							tot += 1
				if tot > 14:
					poss = []
		else:
			boo = False
	return boo

#Permet de suprimer les catalyseurs
def suppCata():
	tot = 0
	for x in range(6):
		for y in range(6):
			if type_case((x, y), moi) == met2[0]:
				tot += 1
	if tot <= 31:
		for x in range(6):
			for y in range(6):
				tc = type_case((x, y), moi)
				if tc == met2[3] or tc == met2[5]:
					if taille_region((x, y), moi) >= 3:
						transPC((x, y))

#Retourne True si le joueur joueur pourra catalyser au prochain tour
def canCata(joueur):
	for x in range(6):
		for y in range(6):
			tc = type_case((x, y), lui)
			if tc == met2[3] or tc == met2[5]:
				if taille_region((x, y), moi) >= 3 or (taille_region((x, y), moi) >= 2 and (d1 == tc or d2 == tc)):
					return True
	return False

#Retourne la taile de la meilleur region de l'adversaire
def bestRE():
	res = 0
	for x in range(6):
		for y in range(6):
			res = max(res, taille_region((x, y), lui))
	return res
	
# Fonction appelée au début de la partie.
def partie_init():
	global moi, lui, met, met2
	moi, lui = moi(), adversaire()
	met2 = [case_type.VIDE, case_type.CUIVRE, case_type.FER, case_type.MERCURE, case_type.PLOMB, case_type.SOUFRE]
	met = {case_type.VIDE : 0, case_type.CUIVRE : 1, case_type.FER : 2, case_type.MERCURE : 3, case_type.PLOMB : 4, case_type.SOUFRE : 5}
	pass

# Fonction appelée à chaque tour.
def jouer_tour():
	do = minEl()
	d1, d2 = do[0], do[1]
	suppCata()
	ech = echantillon_tour()
	amn = amenage(3, ech)
	if not(amn):
		amn = amenage(2, ech)
	poss = placements_possible_echantillon(ech, moi)
	if amn and len(poss) > 0:
		bestP(poss, ech)
	if len(poss) == 0 or tour_actuel() >= 149:
		supp(3)
	suppCata()
	if canCata(lui):
		if canCata(moi):
			supp(7)
		else:
			supp(6)
	pass

# Fonction appelée à la fin de la partie.
def partie_fin():
    # Place ton code ici
	pass

